<?php

/**
 * @file
 * Contains \Drupal\mcapi_cc\Endpoint.
 * Handles incoming requests from ClearingCentral
 */

namespace Drupal\mcapi_cc\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Component\Utility\UrlHelper;
use Symfony\Component\HttpFoundation\Response;

/**
 * Returns responses for requests from ClearingCentral
 */
class Endpoint extends ControllerBase {

  /**
   * Receive the message as server B from clearing central.
   *
   * Validate and save the transaction.
   *
   * @return array transaction || int
   *   The transaction in the remote format or an error code
   */
  function receiver()  {
    $post = filter_input_array(INPUT_POST);
    $this->getLogger('Clearing Central')->debug(print_r($post, 1));

    \Drupal::service('mcapi_cc.clearing_central')->receive($post);

    $status_code = $post['response'] == CEN_SUCCESS ? 201 : 200;
    $response = new Response(UrlHelper::buildQuery($post), $status_code);
    $response->send();
    exit;
  }

}
