<?php

namespace Drupal\mcapi_cc;

use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessCheck;
use Symfony\Component\Routing\Route;

/**
 * Custom Route Access control handler for users to intertrade.
 */
class IntertradeAccess extends EntityAccessCheck {

  /**
   * Access the route if the system is configured with a clearing central login.
   */
  public function access(Route $route, RouteMatchInterface $route_match, AccountInterface $account) {
    $login = \Drupal::config('mcapi_cc.settings')->get('login');
    $result = $login ? AccessResult::allowed() : AccessResult::forbidden('Clearing Central login data not available.');
    return $result->cachePerUser();
  }
}

