<?php

namespace Drupal\mcapi\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Displays all the wallets of an entity.
 *
 * Entity being either the current user OR the entity being viewed. Shows the
 * wallet view mode 'mini'.
 *
 * @Block(
 *   id = "currency_summary",
 *   admin_label = @Translation("Currency summary"),
 *   category = @Translation("Community Accounting")
 * )
 * @todo inject entityTypeManager
 */
class Currencies extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $currencies = mcapi_currencies_available();
    return \Drupal::entityTypeManager()
      ->getViewBuilder('mcapi_currency')
      ->viewMultiple($currencies, 'summary');
  }

}
