<?php

namespace Drupal\mcapi\Plugin\Field;

use Drupal\Core\Field\EntityReferenceFieldItemList;
use Drupal\Core\TypedData\ComputedItemListTrait;

/**
 * Item list for a computed field to calculate the wallet holder.
 */
class WalletHolderItemComputedList extends EntityReferenceFieldItemList {

  use ComputedItemListTrait;

  /**
   * {@inheritdoc}
   */
  public function computeValue() {
    $wallet = $this->getEntity();
      $holder = \Drupal::entityTypeManager()
      ->getStorage($wallet->holder_entity_type->value)
      ->load($wallet->holder_entity_id->value);
    $this->list[0] = $this->createItem(0, $holder);
  }

    /**
   * Computes the calculated values for this item list.
   *
   * In this example, there is only a single item/delta for this field.
   *
   * The ComputedItemListTrait only calls this once on the same instance; from
   * then on, the value is automatically cached in $this->items, for use by
   * methods like getValue().
   */
  protected function ensurePopulated() {
    if (!isset($this->list[0])) {
      $this->list[0] = $this->createItem(0);
    }
  }

  /**
   * {@inheritdoc}
   * @temp I think
   */
  public function filterEmptyItems() {
    return parent::filterEmptyItems();
    // just in case it doesn't work
    $this->filter(function ($item) {
      return (bool)$item;
    });
    return $this;
  }

}
