<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use \Drupal\Core\Entity\Plugin\Validation\Constraint\CompositeConstraintBase;

/**
 * Check that the two wallets in the transaction are different.
 *
 * Supports validating payer & payee of parent transactions.
 *
 * @Constraint(
 *   id = "SameState",
 *   label = @Translation("Checks that the payer and payee wallets are different"),
 * )
 */
class SameStateConstraint extends CompositeConstraintBase {

  public $sameMessage = 'Internal error: All transactions in the cluster must have the same state. Main transaction is @main_state, dependent transaction is @wrong_state';

  /**
   * {@inheritdoc}
   *
   * How is this used?
   */
  public function coversFields() {
    return ['state'];
  }

}
