<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;

/**
 * Check that the two wallets in the transaction are different.
 */
class SameStateConstraintValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($transaction, Constraint $constraint) {
    if ($transaction->children) {
      $state = $transaction->state->target_id;
      foreach ($transaction->flatten() as $t) {
        if ($state != $t->state->target_id) {
          $this->context
            ->buildViolation($constraint->sameMessage, ['@main_state' => $state, '@wrong_state' => $t->state->target_id])
            ->addViolation();
        }
      }
    }

  }
}
