<?php

namespace Drupal\mcapi\Plugin\views\argument;

use \Drupal\views\Plugin\views\argument\NumericArgument;

/**
 * Argument handler to get the first wallet of the entity given in the route.
 *
 * @ingroup views_argument_handlers
 *
 * @ViewsArgument("mcapi_wallet_holder")
 *
 * @todo test whether this is used and needed in relation to the very similar @ViewsArgumentDefault
 */
class WalletHolder extends NumericArgument {

  /**
   * Set up the query for this argument.
   *
   * The argument sent may be found at $this->argument.
   */
  public function query($group_by = FALSE) {
    parent::query($group_by);

    $this->query->addWhere(0, "$this->tableAlias.holder_entity_type", $this->definition['holder_entity_type']);
  }

}
